SystemOrganization addCategory: #'Ma base additions-Info'!
SystemOrganization addCategory: #'Ma base additions-abstractions'!
SystemOrganization addCategory: #'Ma base additions-domains'!

!Rectangle methodsFor: '*ma base additions' stamp: 'cmm 8/25/2003 23:42'!
maPointAtRandom

	^(self topLeft x + self width atRandom) @ (self topLeft y + self height atRandom)! !

!ProtoObject methodsFor: '*ma base additions' stamp: 'cmm 1/16/2005 14:03'!
maInstSize
	"Answer the number of named and indexed instance variables referenced by
	the receiver."

	^self class instSize + self basicSize
! !

!BlockContext methodsFor: '*ma base additions' stamp: 'cmm 12/5/2002 21:43'!
maBench
	"See how many times I can value in 5 seconds.  I'll answer a meaningful description."

	| startTime endTime count |
	count _ 0.
	endTime _ Time millisecondClockValue + 5000.
	startTime _ Time millisecondClockValue.
	[ Time millisecondClockValue > endTime ] whileFalse: [ self value.  count _ count + 1 ].
	endTime _ Time millisecondClockValue.
	^count = 1
		ifTrue: [ ((endTime - startTime) // 1000) printString, ' seconds.' ]
		ifFalse:
			[ ((count * 1000) / (endTime - startTime)) asFloat printString, ' per second.' ]! !

!BlockContext methodsFor: '*ma base additions' stamp: 'cmm 3/23/2003 22:40'!
maOn: exc1 do: block1 on: exc2 do: block2

	^[
		[ self value ]
			on: exc1
			do: block1 ]

		on: exc2
		do: block2! !

!BlockContext methodsFor: '*ma base additions' stamp: 'cmm 3/23/2003 22:43'!
maOn: exc1 do: block1 on: exc2 do: block2 on: exc3 do: block3

	^[
		[ self value ]
			on: exc1
			do: block1 ]

		maOn: exc2
		do: block2

		on: exc3
		do: block3! !

!TimeProfileBrowser class methodsFor: '*ma base additions' stamp: 'cmm 12/24/2003 13:25'!
maOnBlock: block if: conditionBlock
	"Allows you to build up your sample set before invoking the profiler."
	^conditionBlock value 
		ifTrue: [ self onBlock: block ]
		ifFalse: [ block value ]! !

!LargePositiveInteger methodsFor: '*ma base additions' stamp: 'cmm 7/19/2007 21:14'!
maLog: anInteger 
	"Answer the log base aNumber of the receiver."
	| maxFloatLog m |
	maxFloatLog _ 1 bitShift: 1023.
	^ self > maxFloatLog 
		ifTrue: 
			[ "Search for it."
			m _ 1023.
			[ (anInteger raisedTo: m) > self ] whileFalse: [ m _ m + 1 ].
			(m-1) asFloat ]
		ifFalse: [ self log: anInteger ]! !

!ByteString methodsFor: '*ma base additions' stamp: 'cmm 11/10/2005 20:48'!
maAlphabeticalNext
	"Answer the next higher String.  This is useful in indexing systems to search for left-side matching strings."
	| nextValue stream |
	nextValue := (self asByteArray inject: 0 into: [ :sum :each | sum * 256 + each ]) + 1.
	stream := WriteStream on: ByteArray new.
	nextValue digitLength to: 1 by: -1 do:
		[ : digitIndex |
		stream nextPut: (nextValue digitAt: digitIndex) ].
	^ stream contents asString! !

!Number methodsFor: '*ma base additions' stamp: 'cmm 7/18/2007 21:04'!
maLog: anInteger
	^ self log: anInteger! !

!Number methodsFor: '*ma base additions' stamp: 'cm 12/24/2001 16:40'!
maPrintAbbreviatedOn: aStream

	self printOn: aStream
! !

!Dictionary methodsFor: '*ma base additions' stamp: ''!
maAllKeysAtValue: anObject

	| aCollection |

	aCollection := OrderedCollection new.
	self keysAndValuesDo: [ :key :value | value = anObject ifTrue: [ aCollection add: key ] ].
	^aCollection! !

!Dictionary methodsFor: '*ma base additions' stamp: ''!
maAt: anObject ifPresent: oneArgBlock ifAbsent: zeroArgBlock

	| current uniqueObj |

	uniqueObj := 'x'.
	^(current := self
		at: anObject
		ifAbsent: [ uniqueObj ]) == uniqueObj
			ifTrue: [ zeroArgBlock value ]
			ifFalse: [ oneArgBlock value: current ]
! !

!Dictionary methodsFor: '*ma base additions' stamp: 'cmm 9/12/2007 13:02'!
maAt: anObject ifPresent: oneArgBlock ifAbsentPut: zeroArgBlock 
	^ self 
		maAt: anObject
		ifPresent: oneArgBlock
		ifAbsent: 
			[ self 
				at: anObject
				put: zeroArgBlock value ]! !

!Dictionary methodsFor: '*ma base additions' stamp: 'cmm 7/24/2002 20:45'!
maShallowCopy

	| copy |
	copy _ self species new.  "new: seems buggy w/ Dictionaries.."
	self keysAndValuesDo: 
		[ :eachKey :eachValue | copy at: eachKey put: eachValue ].
	^copy! !

!SolidFillStyle methodsFor: '*ma base additions' stamp: 'cmm 12/8/2008 13:38'!
addFillStyleMenuItems: aMenu hand: aHand from: aMorph 
	"Add the items for changing the current fill style of the receiver"
	aMenu 
		add: 'change color...' translated
		target: self
		selector: #changeColorIn:event:
		argument: aMorph! !

!SolidFillStyle methodsFor: '*ma base additions' stamp: 'cmm 12/8/2008 13:41'!
changeColorIn: aMorph event: evt
	"Note: This is just a workaround to make sure we don't use the old color inst var"
	aMorph changeColorTarget: aMorph selector: #fillStyle: originalColor: self hand: evt hand! !

!SortedCollection methodsFor: '*ma base additions' stamp: 'cmm 7/15/2006 15:12'!
maIsSortedCollection
	^ true! !

!WriteStream methodsFor: '*ma base additions' stamp: 'cmm 11/10/2002 20:35'!
endEntry
	"No-op for compatibility with TranscriptStream."! !

!WriteStream methodsFor: '*ma base additions' stamp: 'cmm 7/30/2007 00:23'!
maPrint: anObject 
	anObject maPrintOn: self! !

!WriteStream methodsFor: '*ma base additions' stamp: 'cm 12/24/2001 16:03'!
maPrintAbbreviated: aMaObject

	aMaObject maPrintAbbreviatedOn: self
! !

!WriteStream methodsFor: '*ma base additions' stamp: 'cmm 8/23/2004 17:08'!
maPrintNumber: anInteger template: templateString

self maMarked: 'dev'.
"I hate this method...  Find a better solution and a better name because you only support Integers!!"
	templateString size - anInteger printString size timesRepeat: [ self nextPut: $0 ].
	anInteger maPrintAbbreviatedOn: self! !

!Interval methodsFor: '*ma base additions' stamp: 'cmm 6/4/2005 17:22'!
maEnvelopes: anInterval 
	"Return true if anInterval fits entirely inside the receiver."

	^ (anInterval first between: start and: stop)
	and: [ anInterval last between: start and: stop ]! !

!Interval methodsFor: '*ma base additions' stamp: 'cmm 6/4/2005 01:09'!
maIntersects: anInterval 
	"Return true if the receiver overlaps with anInterval."

	^(start between: anInterval first and: anInterval last) 
		or: [ anInterval first between: start and: stop ]! !

!SecureHashAlgorithm methodsFor: '*ma base additions' stamp: 'cmm 6/9/2005 11:55'!
maHashMessage: aStringOrByteArray from: startPos to: stopPos
	"Hash the given message using the Secure Hash Algorithm."

	^ self
		maHashStream: 
			((ReadStream on: aStringOrByteArray asByteArray)
				position: startPos-1 ;
				yourself)
		to: stopPos! !

!SecureHashAlgorithm methodsFor: '*ma base additions' stamp: 'cmm 6/9/2005 11:59'!
maHashStream: aPositionableStream to: endPosition
	"Hash the contents of the given stream from the current position to endPosition using the Secure Hash Algorithm. The SHA algorithm is defined in FIPS PUB 180-1. It is also described on p. 442 of 'Applied Cryptography: Protocols, Algorithms, and Source Code in C' by Bruce Scheier, Wiley, 1996."

	| currentPosition buf bitLength |
	self initializeTotals.
	aPositionableStream atEnd ifTrue: [self error: 'empty stream'].
	endPosition > aPositionableStream size ifTrue: [ self error: 'invalid endPosition' ].
	[ currentPosition _ aPositionableStream position.
	currentPosition < endPosition ]
		whileTrue:
			[ buf _ aPositionableStream next: (64 min: endPosition-currentPosition).
			(currentPosition < endPosition
			and: [buf size = 64])
				ifTrue: [ self processBuffer: buf ]
				ifFalse: 
					[ bitLength _ (endPosition - currentPosition) * 8.
					self processFinalBuffer: buf bitLength: bitLength ] ].
	^ self finalHash! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 7/9/2002 22:59'!
maConsistsOf: aCollection
	"Answer whether the receiver and aCollection reference all equal
	objects, including the same number of references to those objects.  Order
	is not a factor."

	^self size = aCollection size and: [ self maIncludesAll: aCollection ]
! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 1/16/2002 16:48'!
maDetect: aBlock ifFound: foundBlock ifNone: exceptionBlock 
	"foundBlock takes one argument, the found object."

	self 
		do: [ :element | (aBlock value: element) ifTrue: [ ^foundBlock value: element ] ].
	^exceptionBlock value
! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 7/24/2004 01:05'!
maDo: aBlock while: conditionBlock

	conditionBlock value ifFalse: [ ^ self ].
	self do:
		[ : each |
		aBlock value: each.
		conditionBlock value ifFalse: [ ^ self ] ]! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 12/19/2002 21:32'!
maIncludesAll: aCollection
	"Return true if the receiver includes all elements in aCollection.
	If aCollection contains duplicate elements, the receiver must have
	one for each of them."

	| otherColl |

	aCollection size > self size ifTrue: [ ^false ].
	self size > 20
		ifTrue:
			[ ^self asBag maIncludesAll: aCollection ].
	otherColl :=
		aCollection size > 20
			ifTrue: [ aCollection asBag ]
			ifFalse: [ aCollection ].
	otherColl do:
		[ :each | (self occurrencesOf: each) < (otherColl occurrencesOf: each) ifTrue: [ ^false ] ].
	^true! !

!Collection methodsFor: '*ma base additions' stamp: ''!
maMatchesElementsOf: anotherCollection
	"Answer whether the receiver points to equivalent objects as
	anotherCollection.  In SequencableCollections, the order must be
	the same as well."

	^self maConsistsOf: anotherCollection
! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 8/6/2007 09:23'!
maRemoveAll
	"Efficiently removes all elements from the receiver."
	MaObject isPre3dot9 
		ifTrue: [ self init: (self size max: 4) ]
		ifFalse: [ self initialize: (self size max: 4) ]! !

!Collection methodsFor: '*ma base additions' stamp: ''!
maRemoveAll: aCollection forEachAbsent: aBlock

	^aCollection do:
		[ :element |
		self
			remove: element
			ifAbsent: [ aBlock value: element ] ]
! !

!Array methodsFor: '*ma base additions' stamp: 'cmm 12/1/2004 23:10'!
maInstSize
	"Override from Object because this is considerably faster."
	^ self size! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 6/8/2008 20:55'!
lzCompressed
	| compressor compressed |
	compressed := RWBinaryOrTextStream on: ByteArray new.
	compressor := GZipWriteStream on: compressed.
	compressor nextPutAll: self.
	compressor close.
	^ compressed contents! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 6/8/2008 21:11'!
lzUncompressed
	"I am a ByteArray compressed with lzCompress.  Answer its original, uncompressed, form."
	| compressed |
	compressed := ReadStream on: self.
	^ (GZipReadStream on: compressed) contents! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 3/3/2009 20:51'!
maAsIpString
	"Answer the receiver as a dot-delimited ip address String."
	^ String streamContents: 
		[ : stream | 
		self do: 
			[ : each | 
			stream maPrint: each.
			each = self last ifFalse: [ stream maPrint: $. ] ] ]! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 12/1/2004 23:02'!
maInstSize
	"Override from Object because this is many times faster."
	^ self size! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 3/3/2009 20:53'!
maIsLocalHost
	"Host addresses are represented as ByteArray's in Squeak.  Answer whether this host-address represents a localhost address."
	^ self first = 127 or: [ self = NetNameResolver localHostAddress ]! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 12/19/2008 14:34'!
maUint: bits at: anInteger 
	"oids"
	| answer bytes |
	bits == 48 ifTrue: [ ^ self maUnsigned48At: anInteger + 1 ].
	"control fields - bpMapIndex."
	bits == 8 ifTrue: [ ^ self byteAt: anInteger + 1 ].
	"physicalSize"
	bits == 24 ifTrue: [ ^ self maUnsigned24At: anInteger + 1 ].
	"class ids and classVersions"
	bits == 16 ifTrue: 
		[ ^ self 
			unsignedShortAt: anInteger + 1
			bigEndian: false ].
	"word buffers"
	bits == 32 ifTrue: 
		[ ^ self 
			unsignedLongAt: anInteger + 1
			bigEndian: false ].
	bits == 64 ifTrue: [ ^ self maUnsigned64At: anInteger + 1 ].
	bits == 40 ifTrue: [ ^ self maUnsigned40At: anInteger + 1 ].
	bits == 56 ifTrue: [ ^ self maUnsigned56At: anInteger + 1 ].
	bytes := bits // 8.
	answer := LargePositiveInteger new: bytes.
	1 
		to: bytes
		do: 
			[ : digitPosition | 
			answer 
				digitAt: digitPosition
				put: (self at: digitPosition + anInteger) ].
	^ answer normalize! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 3/18/2005 10:30'!
maUint: bits at: position put: anInteger

	position + 1
		to: position + (bits // 8)
		do:
			[ :pos |
			self
				at: pos
				put: (anInteger digitAt: pos-position) ].
	^anInteger! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 12/19/2008 14:30'!
maUnsigned24At: index
	"Return a 40-bit unsigned integer quantity starting from the given byte index"
	| b0 b1 w |
	w _ self at: index.
	b1 _ self at: index+1.
	b0 _ self at: index+2.
	b1 = 0 ifFalse:[w _ (b1 bitShift: 8) + w].
	b0 = 0 ifFalse:[w _ (b0 bitShift: 16) + w].
	^w! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 12/12/2008 16:09'!
maUnsigned40At: index
	"Return a 40-bit unsigned integer quantity starting from the given byte index"

	| b0 b1 b2 b3 w |

	w _ self at: index.
	b3 _ self at: index+1.
	b2 _ self at: index+2.
	b1 _ self at: index+3.
	b0 _ self at: index+4.

	"Minimize LargeInteger arithmetic"
	b3 = 0 ifFalse:[w _ (b3 bitShift: 8) + w].
	b2 = 0 ifFalse:[w _ (b2 bitShift: 16) + w].
	b1 = 0 ifFalse:[w _ (b1 bitShift: 24) + w].
	b0 = 0 ifFalse:[w _ (b0 bitShift: 32) + w].

	^w! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 12/12/2008 16:09'!
maUnsigned48At: index
	"Return a 48-bit unsigned integer quantity starting from the given byte index"

	| b0 b1 b2 b3 b4 w |

	w _ self at: index.
	b4 _ self at: index+1.
	b3 _ self at: index+2.
	b2 _ self at: index+3.
	b1 _ self at: index+4.
	b0 _ self at: index+5.

	"Minimize LargeInteger arithmetic"
	b4 = 0 ifFalse:[w _ (b4 bitShift: 8) + w].
	b3 = 0 ifFalse:[w _ (b3 bitShift: 16) + w].
	b2 = 0 ifFalse:[w _ (b2 bitShift: 24) + w].
	b1 = 0 ifFalse:[w _ (b1 bitShift: 32) + w].
	b0 = 0 ifFalse:[w _ (b0 bitShift: 40) + w].

	^w! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 12/12/2008 16:08'!
maUnsigned56At: index
	"Return a 56-bit unsigned integer quantity starting from the given byte index"

	| b0 b1 b2 b3 b4 b5 w |

	w _ self at: index.
	b5 _ self at: index+1.
	b4 _ self at: index+2.
	b3 _ self at: index+3.
	b2 _ self at: index+4.
	b1 _ self at: index+5.
	b0 _ self at: index+6.

	"Minimize LargeInteger arithmetic"
	b5 = 0 ifFalse:[w _ (b5 bitShift: 8) + w].
	b4 = 0 ifFalse:[w _ (b4 bitShift: 16) + w].
	b3 = 0 ifFalse:[w _ (b3 bitShift: 24) + w].
	b2 = 0 ifFalse:[w _ (b2 bitShift: 32) + w].
	b1 = 0 ifFalse:[w _ (b1 bitShift: 40) + w].
	b0 = 0 ifFalse:[w _ (b0 bitShift: 48) + w].

	^w! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 3/18/2005 09:59'!
maUnsigned64At: index
	"Return a 32bit unsigned integer quantity starting from the given byte index"

	| b0 b1 b2 b3 b4 b5 b6 w |

	w _ self at: index.
	b6 _ self at: index+1.
	b5 _ self at: index+2.
	b4 _ self at: index+3.
	b3 _ self at: index+4.
	b2 _ self at: index+5.
	b1 _ self at: index+6.
	b0 _ self at: index+7.

	"Minimize LargeInteger arithmetic"
	b6 = 0 ifFalse:[w _ (b6 bitShift: 8) + w].
	b5 = 0 ifFalse:[w _ (b5 bitShift: 16) + w].
	b4 = 0 ifFalse:[w _ (b4 bitShift: 24) + w].
	b3 = 0 ifFalse:[w _ (b3 bitShift: 32) + w].
	b2 = 0 ifFalse:[w _ (b2 bitShift: 40) + w].
	b1 = 0 ifFalse:[w _ (b1 bitShift: 48) + w].
	b0 = 0 ifFalse:[w _ (b0 bitShift: 56) + w].

	^w! !

!ServerDirectory methodsFor: '*ma base additions' stamp: 'cmm 4/4/2007 09:43'!
assureAbsence
	self exists ifTrue: [ self recursiveDelete ]! !

!ServerDirectory methodsFor: '*ma base additions' stamp: 'cmm 4/4/2007 17:20'!
maCopyFileNamed: sourceFilename toDirectory: aFileDirectory 
	| sourceStream |
	sourceStream _ (self readOnlyFileNamed: sourceFilename) binary.
	^ [ aFileDirectory 
		putFile: sourceStream
		named: (aFileDirectory localNameFor: sourceFilename) ]

		ensure: [ sourceStream close ]! !

!FileDirectory methodsFor: '*ma base additions' stamp: 'cmm 4/4/2007 09:39'!
assureAbsence
	self exists ifTrue: [ self recursiveDelete ]! !

!FileDirectory methodsFor: '*ma base additions' stamp: 'cmm 3/23/2007 12:12'!
maCopyFileNamed: sourceFilename toDirectory: aFileDirectory 
	| sourceStream |
	sourceStream _ (self readOnlyFileNamed: sourceFilename) binary.
	^ aFileDirectory 
		putFile: sourceStream
		named: (aFileDirectory localNameFor: sourceFilename)! !

!FileDirectory methodsFor: '*ma base additions' stamp: 'cmm 4/8/2002 20:52'!
maEntriesMatching: pat
	"FileDirectory default fileNamesMatching: '*'"

	^ self entries select: [ :each | pat match: each name ]
! !

!FileDirectory methodsFor: '*ma base additions' stamp: 'cmm 1/23/2009 15:41'!
maFileNamed: aString do: oneArgBlock 
	"A convenient accessing method for accessing a file without having to open and close yourself.  The oneArgBlock argument is the fileStream."
	| fileStream |
	fileStream := self fileNamed: aString.
	fileStream ifNil: 
		[ MaEnvironmentError signal: 'Could not open ' , aString , ' in use?' ].
	^ [ oneArgBlock value: fileStream ] ensure: [ fileStream close ]! !

!FileDirectory methodsFor: '*ma base additions' stamp: 'cmm 12/4/2007 22:44'!
maFindEntries: oneArgBlock 
	"Traverse my directory and answer an OrderedCollection of DirectoryEntry's whose path of DirectoryEntry's causes oneArgBlock to value true."
	| answer |
	answer _ OrderedCollection new.
	self directoryTreeDo: [ : path | (oneArgBlock value: path) ifTrue: [ answer add: path last ] ].
	^ answer! !

!FileDirectory methodsFor: '*ma base additions' stamp: 'cmm 9/20/2007 17:31'!
maFindEntriesMatching: substring 
	"Traverse my directory and answer an OrderedCollection of DirectoryEntry's whose names contain substring."
	"This method focuses on user-convenience; eschewing complex wild-card matching in favor of 'type-and-go'.  But without punishing engineers who still want to use wild-card matching."
	| usePatternMatch |
	usePatternMatch _ substring includesAnyOf: #($* $# ).
	^ self maFindEntries: 
		[ : path | 
		path last name in: 
			[ : theName | 
			usePatternMatch 
				ifTrue: [ substring match: theName ]
				ifFalse: 
					[ theName 
						includesSubstring: substring
						caseSensitive: false ] ] ]! !

!Character methodsFor: '*ma base additions' stamp: 'cmm 7/30/2007 00:22'!
maPrintOn: aStream
	aStream nextPut: self! !

!Character methodsFor: '*ma base additions' stamp: 'cmm 7/24/2002 20:44'!
maShallowCopy
	"Characters are unique."

	^self
! !

!String class methodsFor: '*ma base additions' stamp: 'cmm 1/28/2003 15:51'!
maEmpty
	"Using a canonical empty String can reduce object-count in memory or a large Magma database."

	^''! !

!String methodsFor: '*ma base additions' stamp: 'cmm 7/6/2006 12:11'!
between: minString and: maxString
	^ self >= minString  and: [self <= maxString ]! !

!String methodsFor: '*ma base additions' stamp: ''!
maAsIntegerFromRadix: anInteger
	"Answer a Smalltalk Integer with an equivalent value of the receiver
	represented in radix anInteger."

	^self
		inject: 0
		into: [ :sum :character | (sum * anInteger) + character digitValue ]
! !

!String methodsFor: '*ma base additions' stamp: 'cmm 8/6/2008 21:19'!
maAsNumber
	"Squeak..  Depending on *how* the receiver is not numeric, It sometimes answers 0, other times signals an error."
	| n |
	^ 
	[ n := self asNumber.
	n = 0 ifFalse: [ n ] ] 
		on: Error
		do: [ : err | err return: nil ]! !

!String methodsFor: '*ma base additions' stamp: 'cmm 2/27/2008 23:50'!
maBeginsWith: aString caseSensitive: aBoolean 
	"Returns true if the receiver begins with the elements in aString, while ignoring the case if aBoolean is true."
	self size < aString size ifTrue: [ ^ false ].
	"Optimization.  Most strings will differ on the first character.."
	self first asLowercase = aString first asLowercase ifFalse: [ ^ false ].
	^ (self 
		findSubstring: aString
		in: self
		startingAt: 1
		matchTable: (aBoolean 
				ifTrue: [ CaseSensitiveOrder ]
				ifFalse: [ CaseInsensitiveOrder ])) = 1! !

!String methodsFor: '*ma base additions' stamp: 'cmm 2/28/2008 00:14'!
maEndsWith: aString caseSensitive: aBoolean 
	"Returns true if the receiver begins with the elements in aString,while ignoring the case if aBoolean is true."
	| extra |
	(extra := self size - aString size) < 0 ifTrue: [ ^ false ].
	^ (self 
		findSubstring: aString
		in: self
		startingAt: extra + 1
		matchTable: (aBoolean 
				ifTrue: [ CaseSensitiveOrder ]
				ifFalse: [ CaseInsensitiveOrder ])) > 0! !

!String methodsFor: '*ma base additions' stamp: 'cmm 2/7/2008 17:04'!
maFormattedForPlural: aNumber 
	"This is kind of a wing-nut method, but it can save you some
	redundant code if you care to make your programs user message
	plural and singular friendly.  It will add or remove an s based on
	aNumber and whether or not the receiver already ends in s."
	^ aNumber > 0 & (aNumber <= 1) 
		ifTrue: 
			[ "should not end in s"
			(self 
				maEndsWith: 's'
				caseSensitive: true) 
				ifTrue: 
					[ self 
						copyFrom: 1
						to: self size - 1 ]
				ifFalse: [ self ] ]
		ifFalse: 
			[ (self 
				maEndsWith: 's'
				caseSensitive: true) 
				ifTrue: 
					[ "should end in s"
					self ]
				ifFalse: [ self , 's' ] ]! !

!String methodsFor: '*ma base additions' stamp: 'cmm 12/1/2004 23:02'!
maInstSize
	"Override from Object because this is many times faster."
	^ self size! !

!String methodsFor: '*ma base additions' stamp: 'cmm 7/30/2007 00:18'!
maPrintAbbreviatedOn: aStream 
	aStream nextPutAll: self! !

!String methodsFor: '*ma base additions' stamp: 'cmm 7/30/2007 00:22'!
maPrintOn: aStream
	aStream nextPutAll: self! !

!String methodsFor: '*ma base additions' stamp: 'cmm 2/2/2008 16:55'!
occurrence: anInteger where: oneArgBlock 
	^ self 
		occurrence: anInteger
		where: oneArgBlock
		startingAt: 1! !

!String methodsFor: '*ma base additions' stamp: 'cmm 2/2/2008 17:04'!
occurrence: anInteger where: oneArgBlock startingAt: startPos 
	"Answer the position of the anInteger'th Character, aCharacter, in the receiver.  If not found, answer 0."
	| pos count |
	count := 0.
	pos := startPos.
	[ pos < self size and: [ count < anInteger ] ] whileTrue: 
		[ (oneArgBlock value: (self at: pos)) ifTrue: [ count := count + 1 ].
		pos := pos + 1 ].
	^ count = anInteger 
		ifTrue: [ pos-1 ]
		ifFalse: [ 0 ]! !

!String methodsFor: '*ma base additions' stamp: 'cmm 11/5/2007 01:00'!
smalltalkToWords
	"smalltalkString may be a Smalltalk class name, method name, or a parameter name (aString or smalltalkString).
	
	'MauiUserStrategy' answers 'Maui User Strategy'
	'smalltalkToWords:' answers 'Smalltalk To Words:'
	'aString' answers 'A String'
	'aMaObjectSerializer' answers 'A Ma Object Serializer'
	'aMagmaSession' answers 'A Magma Session'
	'A typical overridden name:' answers 'A typical overridden name:'"
	| smalltalkStream words |
	smalltalkStream _ self readStream.
	words _ String streamContents: 
		[ : stream | 
		[ smalltalkStream atEnd ] whileFalse: 
			[ (smalltalkStream peek isUppercase and: [ stream isEmpty not and: [ stream last ~= Character space ] ]) ifTrue: [ stream space ].
			stream isEmpty 
				ifTrue: [ stream nextPut: smalltalkStream next asUppercase ]
				ifFalse: [ stream nextPut: smalltalkStream next ] ] ].
	^ words! !

!Behavior methodsFor: '*ma base additions' stamp: 'cmm 12/2/2004 15:07'!
maAllInstVarNamesDo: aBlock

	superclass ifNotNil: [ superclass maAllInstVarNamesDo: aBlock ].
	self instVarNames do: aBlock! !

!Behavior methodsFor: '*ma base additions' stamp: 'cmm 12/16/2004 01:26'!
maAllSelectorsDo: aBlock

	self selectorsDo: aBlock.
	superclass ifNotNil: [ superclass maAllSelectorsDo: aBlock ]! !

!Behavior methodsFor: '*ma base additions' stamp: 'cmm 12/3/2007 21:13'!
maFirstCommentAt: selector 
	"A much more-convenient method than firstCommentAt:, which requires you to specify the exact class, a problem when the method is implemented in the superclass methodDict."
	^ (self methodDict includesKey: selector) 
		ifTrue: [ self firstCommentAt: selector ]
		ifFalse: 
			[ self superclass 
				ifNil: [ '' ]
				ifNotNil: [ self superclass maFirstCommentAt: selector ] ]! !

!Behavior methodsFor: '*ma base additions' stamp: 'cmm 11/19/2003 22:53'!
maFirstCommentOrNilAt: selector
	"A much more-convenient method than firstCommentAt:, which requires you to specify the exact class, a problem when the method is implemented in the superclass methodDict."

	| string |
	^(string _ self maFirstCommentAt: selector) isEmpty
		ifTrue: [ nil ]
		ifFalse: [ string ]! !

!Stream methodsFor: '*ma base additions' stamp: 'cmm 7/9/2008 21:00'!
ensureOpen
	"Base squeak assumes the need for some releasing FileStream compatibility.  However, the initializing compatibility was overlooked.  This provides some."
	^ self! !

!Stream methodsFor: '*ma base additions' stamp: 'cmm 7/9/2008 21:00'!
open
	"Base squeak assumes the need for some releasing FileStream compatibility.  However, the initializing compatibility was overlooked.  This provides some."
	^ self! !

!CompiledMethod methodsFor: '*ma base additions' stamp: 'cmm 12/17/2008 20:29'!
maSourceString
	^ self getSource asString! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 12/3/2008 10:40'!
maActualMethod

	| class |
	^(class _ self actualClass)
		ifNil: [ nil ]
		ifNotNil:
			[ (class canUnderstand: self selector)
				ifTrue: [ class >> self selector ]
				ifFalse: [ nil ] ]! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 12/4/2008 19:38'!
maAuthor
	"Answer the author initials of the current version of this method."
	^ self maActualMethod ifNotNilDo: 
		[ : cm | 
		cm timeStamp subStrings ifNotEmptyDo: [ : strings | strings first ] ]! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 8/19/2003 23:53'!
maCategory
	^ self actualClass organization categoryOfElement: methodSymbol! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 12/3/2008 00:00'!
maClassHierarchy
	^ self actualClass withAllSuperclasses reversed! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 12/3/2008 19:07'!
maImplementors
	"Answer a collection of MethodReferences with the same selector as myself."
	^ self systemNavigation allImplementorsOf: self selector! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 12/3/2008 19:09'!
maMethodHierarchy
	"Answer an OrderedCollection of methods in my class-hierarchy with the same selector as mine."
	| superclasses answer |
	answer := OrderedCollection new.
	superclasses := self actualClass allSuperclasses reverse.
	superclasses do: 
		[ : each | 
		(each includesSelector: self selector) ifTrue: [ answer add: (each >> self selector) methodReference ] ].
	self actualClass 
		allSubclassesWithLevelDo: 
			[ : eachClass : level | 
			(eachClass includesSelector: self selector) ifTrue: [ answer add: (eachClass >> self selector) methodReference ] ]
		startingLevel: 0.
	^ answer! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 12/3/2008 19:48'!
maPackageInfo
	"Answer the PackageInfo containing this method."
	| methodCategory classCategory |
	methodCategory := self maCategory.
	classCategory := methodCategory first = $* ifFalse: [ self actualClass theNonMetaClass category ].
	^ PackageInfo allPackages 
		maDetect: 
			[ : each | 
			"maDetect: [ : each | each methods includes: self ]"
			"<-- too slow"
			(each isYourClassExtension: methodCategory) or: 
				[ classCategory notNil and: [ each systemCategories includes: classCategory ] ] ]
		ifFound: [ : foundPackage | foundPackage ]
		ifNone: [ nil ]! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 12/3/2008 17:46'!
maSenders
	"Answer a collection of MethodReferences that send my selector."
	^ self systemNavigation allCallsOn: self selector! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 12/3/2008 17:46'!
maSentMessages
	"Answer a Collection of MethodReferences possibly called by this method."
	^ self maSentSelectors 
		inject: OrderedCollection new
		into: 
			[ : oc : each | 
			oc
				addAll: (self systemNavigation allImplementorsOf: each) ;
				yourself ]! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 12/2/2008 23:38'!
maSentSelectors
	^ self maActualMethod 
		ifNil: 
			[ #() ]
		ifNotNilDo: [ : cm | cm messages ]! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 12/4/2008 19:37'!
maTimeStamp
	"Answer the author initials of the current version of this method."
	^ self maActualMethod ifNotNilDo: 
		[ : cm | 
		cm timeStamp subStrings ifNotEmptyDo: 
			[ : strings | 
			DateAndTime 
				date: strings second asDate
				time: strings third asTime ] ]! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 12/3/2008 10:37'!
selector
	^ self methodSymbol! !

Object subclass: #MaObject
	instanceVariableNames: ''
	classVariableNames: 'NumericVersion'
	poolDictionaries: ''
	category: 'Ma base additions-abstractions'!

!MaObject commentStamp: 'cmm 10/25/2005 22:43' prior: 0!
I provide automatic initialization (which was later added to Squeak 3.7), and the notion of a verbose (standard printOn:) and concise (maPrintAbbreviatedOn:) forms for brevity in collections.!

!MaObject class methodsFor: 'as yet unclassified' stamp: 'cmm 8/6/2007 09:09'!
compileInitializingNewMethod
	MaObject class 
		compile: 
'new
	^ super new initialize'
		classified: 'initialize'! !

!MaObject class methodsFor: 'as yet unclassified' stamp: 'cmm 8/6/2007 09:09'!
initialize
	"For Squeak 3.7 and beyond, objects are initialized automatically.  For <= 3.6, including Jasmine (Croquet), initialization must be performed by the end-user program."
	| imageVersion |
	imageVersion _ SystemVersion current version.
	imageVersion size > 'Squeak' size ifTrue: 
		[ "Try to extract version number.."
		NumericVersion _ 
		[ (imageVersion 
			copyFrom: 7
			to: imageVersion size) asNumber ] 
			on: Error
			do: [ : err | err return: 0.0 ].
		(NumericVersion isNil or: [ NumericVersion < 3.7 ]) ifTrue: [ self compileInitializingNewMethod ] ]! !

!MaObject class methodsFor: 'as yet unclassified' stamp: 'cmm 8/6/2007 09:21'!
isPre3dot9
	^ { 3.7. 3.8 } includes: self numericVersion! !

!MaObject class methodsFor: 'as yet unclassified' stamp: 'cmm 9/20/2006 00:24'!
numericVersion
	"SystemVersion current offers no fast way to check the version, this is much, much faster."
	^ NumericVersion! !

!MaObject methodsFor: 'private' stamp: ''!
initialize

	"Default, do nothing."
! !

!MaObject methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:13'!
printOn: aStream

	super printOn: aStream.
	aStream space.
	self maPrintAbbreviatedOn: aStream
! !

MaObject subclass: #MaSingleton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-abstractions'!

MaSingleton class
	instanceVariableNames: 'current'!

MaSingleton class
	instanceVariableNames: 'current'!

!MaSingleton class methodsFor: 'accessing' stamp: 'cmm 1/10/2005 21:55'!
current

	^ current ifNil: [ current _ self new ]! !

!MaSingleton class methodsFor: 'actions' stamp: 'cmm 1/10/2005 21:54'!
initialize

	super initialize.
	self reset! !

!MaSingleton class methodsFor: 'actions' stamp: 'cmm 1/10/2005 21:56'!
reset

	current _ nil! !

MaObject subclass: #MaTextMessage
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-domains'!

!MaTextMessage commentStamp: '<historical>' prior: 0!
This little tool helps you build non-wimpy message strings.!

!MaTextMessage methodsFor: 'building' stamp: 'cmm 3/6/2002 22:47'!
append: aString

	self appendString: aString
! !

!MaTextMessage methodsFor: 'building' stamp: ''!
appendAndedList: aCollection

	self
		appendList: (
			aCollection
				collect: [ :each | each isString ifTrue: [ each ] ifFalse: [ each printString ] ])
		with: ' and '
! !

!MaTextMessage methodsFor: 'building' stamp: ''!
appendCount: aNumber of: aString
	"aString should be a non-plural word.  This method will append the
	plural version of aString (by simply adding 's') if aNumber is > 1."

	self
		append: aNumber;
		space.
	self
		appendProperlyPluralized: aString
		for: aNumber
! !

!MaTextMessage methodsFor: 'private initializing' stamp: ''!
appendList: aCollection with: aString

	| index |

	aCollection isEmpty ifTrue: [ ^nil ].
	index := 1.
	aCollection do:
		[ :each |
		self append: each.
		aCollection size > 1
			ifTrue:
				[ index < (aCollection size - 1)
					ifTrue:
						[ self append: ', ' ]
					ifFalse:
						[ index = (aCollection size - 1) ifTrue: [ self append: aString ] ] ].
		index := index + 1 ]
! !

!MaTextMessage methodsFor: 'building' stamp: 'cmm 11/25/2003 00:19'!
appendProperlyPluralized: aString for: aNumber
	"aString should be a non-plural word.  This method will append the
	plural version of aString (by simply adding 's') if aNumber is > 1."

	self append: aString.
	aString last asLowercase = $s
		ifTrue: [ stream nextPut: $' ]
		ifFalse: [ stream nextPut: $s ]! !

!MaTextMessage methodsFor: 'private building' stamp: 'cmm 11/25/2003 00:17'!
appendString: anObject

	anObject isString 
		ifTrue: [ stream nextPutAll: anObject ] 
		ifFalse: [ anObject printOn: stream ]! !

!MaTextMessage methodsFor: 'private initializing' stamp: 'cmm 11/25/2003 00:16'!
initialize

	super initialize.
	stream _ String new writeStream! !

!MaTextMessage methodsFor: 'accessing' stamp: 'cmm 11/25/2003 00:22'!
messageText

	stream last = $. ifFalse: [ stream nextPut: $. ].
	^stream contents
! !

!MaTextMessage methodsFor: 'building' stamp: 'cmm 12/27/2008 16:24'!
space
	self append: ' '! !

!MaTextMessage methodsFor: 'private accessing' stamp: 'cmm 11/25/2003 00:16'!
string

	^stream contents! !

MaObject subclass: #MaTimer
	instanceVariableNames: 'name process monitor expired delay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-domains'!

!MaTimer commentStamp: 'cmm 5/2/2008 11:59' prior: 0!
A very simple class to perform a Block after a specified amount of time.  #cancel will stop the countdown.  #expired answers true if the timer expired and the do Block executed.!

!MaTimer class methodsFor: 'as yet unclassified' stamp: 'cmm 5/10/2008 13:09'!
unload
	self allInstancesDo: [ : each | each cancel ]! !

!MaTimer methodsFor: 'access' stamp: 'cmm 6/4/2008 08:55'!
cancel
	"Only allow termination while the delay is running, not while the do block is running."
	process ifNil: [ ^ self ].
	expired ifTrue: 
		[ "There's no canceling now..!!"
		^ self ].
	"Don't allow process to terminate itself."
	process == Processor activeProcess ifTrue: [ MaSoftwareError signal: 'Do not cancel from this process!!' ].
	monitor 
		ifNil: [ process terminate ]
		ifNotNil: [ monitor critical: [ process terminate ] ].
	process := nil! !

!MaTimer methodsFor: 'access' stamp: 'cmm 12/15/2008 17:42'!
expired
	"Answer whether the waiting period before executing my do block has elapsed.  It does not indicate whether the do block has executed or not."
	^ self started and: [ monitor critical: [ expired ] ]! !

!MaTimer methodsFor: 'access' stamp: 'cmm 12/19/2008 14:19'!
in: aDuration do: aBlock 
	process := 
	[ monitor := Mutex new.
	expired := false.
	delay := (Delay forDuration: aDuration) wait.
	name ifNil: [ name := 'MaTimer for ' , aDuration printString ].
	monitor critical: 
		[ expired := true.
		aBlock value ] ] newProcess.
	process
		name: self name ;
		priority: Processor userInterruptPriority-1.
	process resume! !

!MaTimer methodsFor: 'initialize' stamp: 'cmm 3/7/2008 17:08'!
initialize
	super initialize.
	expired := false! !

!MaTimer methodsFor: 'access' stamp: 'cmm 6/5/2008 22:10'!
name
	^name! !

!MaTimer methodsFor: 'access' stamp: 'cmm 6/5/2008 22:10'!
name: anObject
	name := anObject! !

!MaTimer methodsFor: 'access' stamp: 'cmm 12/15/2008 17:42'!
resetDelay
	"If I am still counting down to ding, reset my Delay timer back to the original duration.  Otherwise, do nothing.  
	This might make me useful as a countdown timer to disconnect after a period of inactivity."
	self started ifFalse: [ ^ self ].	"not yet started.."
	monitor critical: [ delay ifNotNil: [ delay maReset ] ]! !

!MaTimer methodsFor: 'access' stamp: 'cmm 12/15/2008 17:41'!
started
	^ monitor notNil! !

Object subclass: #MaOverrider
	instanceVariableNames: 'overriders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-domains'!

!MaOverrider commentStamp: '<historical>' prior: 0!
I provide a list of objects a chance to handle a message and answer a non-nil before allowing the overridee a chance.  Primarily, I am intended to provide chain-of-responsibility for preferences.  A global preferences object is shared by most, but need to be selectively overridden.!

!MaOverrider methodsFor: 'building' stamp: 'cmm 3/3/2004 22:45'!
addOverrider: anObject

	overriders add: anObject! !

!MaOverrider methodsFor: 'private' stamp: 'cmm 3/3/2004 22:53'!
doesNotUnderstand: aMessage

	overriders do:
		[ : each |
		(each respondsTo: aMessage selector)
			ifTrue: 
				[ | answer |
				answer _ aMessage sentTo: each.
				answer ifNotNil: [ ^ answer ] ] ].
	^ aMessage sentTo: self overridee! !

!MaOverrider methodsFor: 'private' stamp: 'cmm 7/1/2004 10:50'!
initialize
	super initialize.
	overriders := OrderedCollection new: 1! !

!MaOverrider methodsFor: 'subclass responsibility' stamp: 'cmm 3/3/2004 22:54'!
overridee

	self subclassResponsibility! !

!MaOverrider methodsFor: 'building' stamp: 'cmm 3/3/2004 22:45'!
removeOverrider: anObject

	overriders remove: anObject! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 8/21/2004 15:53'!
maAbbreviatedString
	"This is intended to support two possible string representations for any object
	instead of just one.  The normal one and this abbreivated one.  The normal one provides type-information, the abbreviation provides the identifier.  An abbreviated
	provides a brevity that proves useful when looking at collections or
	other 'container' type objects.

	Suggested usage is to omit the objects type (e.g. class name) for printing abbreviated,
	but include it for standard printOn:"

	^ String streamContents: [ : stream | self maPrintAbbreviatedOn: stream ]! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 7/15/2006 15:12'!
maIsSortedCollection
	^ false! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 11/10/2005 22:07'!
maMarked: aString
	"This is a marker method used to indicate that we wish to come back and re-examine
	code in the future for possible improvement.  For now, try to keep improvements categorized
	via anEsAtom that we can Browse References to, if necessary.  The possibilities should be:

		'ugly'
		'performance'
		'bug'
		'dev'
		'vmSpecific'
		'releaseSpecific'
		'otherPackageSupport'
		'system override'
		'deprecated'
		'magic'
		'debug'
	A *comment* then should follow to provide more detail."

	aString = 'delete' ifTrue: [ self halt: 'Oops..  looks like you still need this method.' ]! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 2/7/2008 16:56'!
maOriginalClass
	"Unfortunately, we don't have complete class-transparency with WriteBarrier.  #species isn't always the quite the thing needed.  In rare cases (browse my senders), my actual class is needed."
	^ self class! !

!Object methodsFor: '*ma base additions' stamp: 'cm 12/29/2001 01:14'!
maPrintAbbreviatedOn: aStream
	"This is intended to support two possible string representations for any object
	instead of just one.  The normal one and this abbreivated one.  An abbreviated
	provides a brevity that proves useful when looking at collections or
	other 'container' type objects.

	Suggested usage is to omit the objects type (e.g. class name) for printing abbreviated,
	but include it for standard printOn:"
! !

!Object methodsFor: '*ma base additions' stamp: ''!
maPrintAttribute: aSymbol on: aStream

	(self class allInstVarNames includes: aSymbol asString)
		ifTrue:
			[ self
				maPrintInstVar: aSymbol
				on: aStream ]
		ifFalse:
			[ self
				maPrintSelector: aSymbol
				on: aStream ]
! !

!Object methodsFor: '*ma base additions' stamp: ''!
maPrintAttributes: arrayOfSymbols on: aStream

	arrayOfSymbols do:
		[ :each |
		self
			maPrintAttribute: each
			on: aStream ]
! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 12/19/2002 23:26'!
maPrintInstVar: aSymbol on: aStream

	| value |

	aStream
		cr;
		tab;
		nextPutAll: aSymbol;
		nextPutAll: ' = '.
	value := self instVarNamed: aSymbol asString.
	(value isCollection and: [ value isString not ])
		ifTrue:
			[ value do:
				[ :each |
				aStream
					maPrint: each;
					space ] ]
		ifFalse:
			[ aStream maPrint: value ]
! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 7/30/2007 00:23'!
maPrintOn: aStream
	self printOn: aStream! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 5/2/2008 11:48'!
maPrintSelector: aSymbol on: aStream

	| value |

	aStream
		cr;
		tab;
		nextPutAll: aSymbol;
		nextPutAll: ' : '.
	value :=
		[ self perform: aSymbol ]
			on: Error
			do: [ :exc | exc return: (exc messageText ifNil: [ 'error' ]) ].
	(value isCollection and: [ value isString not ])
		ifTrue:
			[ value do:
				[ :each |
				aStream
					maPrint: each;
					space ] ]
		ifFalse:
			[ aStream maPrint: value ]! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 7/24/2002 20:46'!
maShallowCopy

	^self shallowCopy! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 7/9/2008 20:39'!
realObject
	"Balance API with MagmaForwardingProxy, so applications may sometimes choose to get hold of the actual object, not just a forwardingProxy."
	^ self! !

!ReadStream methodsFor: '*ma base additions' stamp: 'cmm 7/1/2003 22:12'!
maUpToIncluding: anObject

	| start end |
	start _ position+1.
	end _ collection indexOf: anObject startingAt: start ifAbsent: [ 0 ].

	"not present--return rest of the collection"	
	end = 0 ifTrue: [ ^self upToEnd ].

	"skip to the end and return the data passed over"
	position _ end.
	^collection copyFrom: start to: end! !

PackageInfo subclass: #MaBaseAdditionsPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-Info'!

!MaBaseAdditionsPackageInfo class methodsFor: 'overriding' stamp: 'cmm 12/27/2008 13:27'!
packageName
	^'Ma base additions'! !

!MaBaseAdditionsPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 12/27/2008 13:49'!
prerequisitePackageNames
	^ #('Ma exception handling' )! !

!MaBaseAdditionsPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 5/8/2008 21:56'!
readmeText

	^'I consist of several method extensions that all begin with the letters "ma".  These are methods that I needed for one or more of the other "Ma" frameworks, but felt it was general enough to be useful to other programs.'! !

!PackageInfo class methodsFor: '*ma base additions' stamp: 'cmm 12/27/2008 13:44'!
classFor: packageNameString 
	self allSubclassesDo: [ : each | each packageName = packageNameString ifTrue: [ ^ each ] ].
	^ self! !

!PackageInfo class methodsFor: '*ma base additions' stamp: 'cmm 12/27/2008 13:41'!
maNamed: aString 
	"Alternative to #named: that provides allows you to register your own PackageInfo subclasses."
	| firstTry |
	firstTry := PackageOrganizer default 
		packageNamed: aString
		ifAbsent: [ nil ].
	^ (firstTry isNil or: [ firstTry class ~= (self classFor: aString) ]) 
		ifTrue: [ (self maNewNamed: aString) register ]
		ifFalse: [ firstTry ]! !

!PackageInfo class methodsFor: '*ma base additions' stamp: 'cmm 12/27/2008 13:38'!
maNewNamed: aString 
	^ (self classFor: aString) new
		packageName: aString ;
		register ;
		yourself! !

!PackageInfo class methodsFor: '*ma base additions' stamp: 'cmm 12/27/2008 13:26'!
packageName
	"Subclasses announce their presence for a particular package by overriding this method, answering the packageName of the package they wish to represent.  This is useful for the #classFor: factory method."
	^ nil! !

!PackageInfo methodsFor: '*ma base additions' stamp: 'cmm 3/17/2009 10:32'!
mcPackages
	^ self prerequisitePackageNames collect: [ : each | MCPackage name: each ]! !

!PackageInfo methodsFor: '*ma base additions' stamp: 'cmm 3/17/2009 10:22'!
patchNames
	"Answer a collection of change-set patches required for this package."
	^ #()! !

!PackageInfo methodsFor: '*ma base additions' stamp: 'cmm 12/27/2008 13:50'!
prerequisitePackageNames
	^ Array new! !

!PackageInfo methodsFor: '*ma base additions' stamp: 'cmm 12/27/2008 13:51'!
prerequisites
	^ self prerequisitePackageNames collect: [ : each | PackageInfo maNamed: each ]! !

!PackageInfo methodsFor: '*ma base additions' stamp: 'cmm 12/3/2008 19:41'!
printOn: aStream 
	super printOn: aStream.
	aStream
		space ;
		nextPutAll: self packageName! !

!Date methodsFor: '*ma base additions' stamp: 'cmm 7/29/2008 23:14'!
maAddYears: anInteger 
	"Answer a new date anInteger years after or, if anInteger is negative, before, the receiver."
	^ Date 
		newDay: self dayOfMonth
		month: self monthIndex
		year: self year + anInteger! !

!DirectoryEntry methodsFor: '*ma base additions' stamp: 'cmm 8/19/2007 21:36'!
maFileSizeString
	"Answer my file size as an easy-to-read String."
	^ self fileSize maAsBytesDescription! !

!SmalltalkImage methodsFor: '*ma base additions' stamp: 'cmm 12/18/2008 10:15'!
saveImageInFileNamed: aString andQuit: aBoolean
	| fullImageName |
	fullImageName _ (FileDirectory default fullNameFor: aString).
	(FileDirectory default directoryNamed:(FileDirectory dirPathFor: fullImageName )) assureExistence.
	self
		changeImageNameTo: fullImageName;
		closeSourceFiles;
		openSourceFiles;  "so SNAPSHOT appears in new changes file"
		saveImageSegments;
		snapshot: true andQuit: aBoolean! !

!SharedQueue methodsFor: '*ma base additions' stamp: 'cmm 2/8/2005 23:34'!
notEmpty

	^ self isEmpty not! !

!Bag methodsFor: '*ma base additions' stamp: 'cmm 12/19/2002 21:33'!
maIncludesAll: aCollection
	"Return true if the receiver includes all elements in aCollection.
	If aCollection contains duplicate elements, the receiver must have
	one for each of them."

	| otherColl |

	aCollection size > self size ifTrue: [ ^false ].
	otherColl :=
		aCollection size > 20
			ifTrue: [ aCollection asBag ]
			ifFalse: [ aCollection ].
	otherColl do:
		[ :each | (self occurrencesOf: each) < (otherColl occurrencesOf: each) ifTrue: [ ^false ] ].
	^true! !

!Bag methodsFor: '*ma base additions' stamp: 'cmm 10/23/2002 20:20'!
maRemoveAll
	"Efficiently removes all elements in the receiver."

	self setContents: (self class contentsClass new: contents size)! !

!Bag methodsFor: '*ma base additions' stamp: 'cmm 11/12/2007 00:01'!
printOn: aStream 
	aStream nextPutAll: 
		(self class name first isVowel 
			ifTrue: [ 'an ' ]
			ifFalse: [ 'a ' ]).
	self species printOn: aStream.
	contents keysAndValuesDo: 
		[ : eachKey : eachValue | 
		aStream
			cr ;
			tab ;
			maPrint: eachValue ;
			space ;
			nextPutAll: 'occurrencesOf: ' ;
			maPrint: eachKey ]! !

!Integer methodsFor: '*ma base additions' stamp: 'cmm 4/13/2007 16:46'!
maAsBytesDescription
	| suffixes |
	suffixes _ { 'k'"ilobytes". 'M'"egabytes". 'G'"igabytes". 'T'"erabytes". 'P'"etabytes". 'E'"xabytes". 'Z'"ettabytes". 'Y'"ottabytes"}.
	suffixes size to: 1 by: -1 do:
		[ : index |  | units |
		units _ 1000 raisedTo: index.
		self > units ifTrue: [ ^ ((self / units) asFloat roundTo: 0.01) asString, (suffixes at: index) ] ].
	^ self asString! !

!Integer methodsFor: '*ma base additions' stamp: 'cmm 6/19/2007 21:53'!
maBitClear: index 
	"Return the receiver with the bit at index cleared."
	^ self bitAnd: (1 bitShift: index - 1) - 1! !

!Integer methodsFor: '*ma base additions' stamp: 'cmm 4/29/2005 17:12'!
maBitSet: index

	"Return the receiver with the bit at index set."

	^self bitOr: (1 bitShift: index - 1)! !

!Integer methodsFor: '*ma base additions' stamp: 'cmm 9/1/2006 17:51'!
maIsBitClear: bitPosition 
	^ (self maIsBitSet: bitPosition) not! !

!Integer methodsFor: '*ma base additions' stamp: 'cmm 9/1/2006 17:52'!
maIsBitSet: bitPosition 
	^ self 
		anyBitOfMagnitudeFrom: bitPosition
		to: bitPosition! !

!Set methodsFor: '*ma base additions' stamp: 'cmm 7/24/2002 20:41'!
maShallowCopy

	| copy |
	copy _ self species new: self size.
	self do: [ :each | copy add: each ].
	^copy! !

!SystemNavigation class methodsFor: '*ma base additions' stamp: 'cmm 3/3/2004 22:57'!
maDefault: aSystemNavigation

	Default _ aSystemNavigation! !

!SystemNavigation methodsFor: '*ma base additions' stamp: 'cmm 1/2/2005 23:31'!
maAllMethodReferencesDo: aBlock
	"Value aBlock for every method in the system."
	Cursor execute showWhile:
		[ self
			allBehaviorsDo:
				[ : class |
				class selectorsDo:
					[ : sel | 
					aBlock value: (MethodReference class: class selector: sel) ] ] ]! !

!OrderedCollection methodsFor: '*ma base additions' stamp: 'cm 1/7/2002 16:25'!
maAddAll: aSequenceableCollection afterIndex: integerIndex

	aSequenceableCollection reverseDo: [:each | self add: each afterIndex: integerIndex ].
	^aSequenceableCollection
! !

!OrderedCollection methodsFor: '*ma base additions' stamp: 'cmm 10/23/2002 20:33'!
maRemoveAll

	self setCollection: (Array new: self size)! !

!SequenceableCollection methodsFor: '*ma base additions' stamp: 'cmm 9/4/2007 12:27'!
maAt: anObject ifPresent: oneArgBlock ifAbsent: zeroArgBlock 
	| current uniqueObj |
	uniqueObj _ 'x'.
	^ (current _ self 
		at: anObject
		ifAbsent: [ uniqueObj ]) == uniqueObj 
		ifTrue: [ zeroArgBlock value ]
		ifFalse: [ oneArgBlock value: current ]! !

!SequenceableCollection methodsFor: '*ma base additions' stamp: 'cmm 5/18/2004 12:01'!
maMatchesElementsOf: anotherCollection
	"Answer whether the receiver points to equivalent objects as
	anotherCollection and in the same order."

	self == anotherCollection ifTrue: [ ^ true ].
	self size = anotherCollection size ifFalse: [ ^false ].
	self
		with: anotherCollection
		do: [ :eachInSelf :eachInOther | eachInSelf = eachInOther ifFalse: [ ^false ] ].
	^true
! !

!SequenceableCollection methodsFor: '*ma base additions' stamp: 'brp 4/7/2005 09:14'!
maMerge: aCollection sortBlock: sortBlock collectBlock: collectBlock
	"Merge the receiver with aCollection"

	| answer first last a b swap |
	self isEmpty ifTrue: [^aCollection asOrderedCollection].
	aCollection isEmpty ifTrue: [^self asOrderedCollection].
	answer := OrderedCollection new: self size + aCollection size.
	first := self readStream.
	last := aCollection readStream.
	a := first next.
	b := last next.
	[true] whileTrue: [
		[(sortBlock value: a value: b) or: [(sortBlock value: b value: a) not]]
			whileTrue: [
				answer addLast: (collectBlock value: a).
				first atEnd ifTrue: [
					answer addLast: (collectBlock value: b).
					last upToEnd do: [ :l | answer addLast: (collectBlock value: l)].
					^ answer ].
				a := first next ].
		swap := first.
		first := last.
		last := swap.
		swap := a.
		a := b.
		b := swap ]
! !

!Delay methodsFor: '*ma base additions' stamp: 'cmm 9/1/2004 22:25'!
maReset
	"If I am already waiting, start my wait back at the beginning.  If I'm not yet waiting, no effect."
	resumptionTime _ Time millisecondClockValue + delayDuration! !

!Message methodsFor: '*ma base additions' stamp: 'cmm 7/10/2003 23:12'!
maArguments: anArray

	args _ anArray! !
MaObject initialize!
MaSingleton initialize!
